from pymoo.algorithms.moo.nsga2 import NSGA2
# from pymoo.algorithms.moo.unsga3 import UNSGA3
from pymoo.indicators.hv import Hypervolume
from evaluate2O import ESNTrain
from pymoo.optimize import minimize
from terminacion2 import NoCambio
from pymoo.visualization.scatter import Scatter
from pymoo.util.display.column import Column
from pymoo.util.display.output import Output
import time
import numpy as np


class MyOutput(Output):

    def __init__(self):
        super().__init__()
        # self.H = Column("H", width=13)
        # self.columns += [self.H]

    def update(self, algorithm):
        super().update(algorithm)
        # self.H.set(Hypervolume(ref_point= np.array([0.01, 1001]), zero_to_one=True, ideal=np.array([-1.0, 5]), nadir=np.array([0, 1000])).do(algorithm.pop.get("F")))


# ref_dirs = np.array([[1.0, 1.0]])

# create the algorithm object
# algorithm = UNSGA3(ref_dirs, pop_size=70)
algorithm = NSGA2( pop_size=80 )

problem = ESNTrain()

# Si no existe un cambio 
# en 10 genereaciones con el individuo
# con la mayor exactitud 
termination = NoCambio(10)

s=1
strF = "F"+str(s)+".txt"
strX = "X"+str(s)+".txt"
st = time.time()
res = minimize(problem,
               algorithm,
               # Para fijar el número de generaciones
               # ('n_gen', 100 ),
               termination,
               seed=s,
               save_history=True,
               output=MyOutput(),
               verbose=True)
et = time.time()
final=(et-st) / 60
print("tiempo "+str(final))
print("Best solution found: \nX = %s\nF = %s" % (res.X, res.F))
#Scatter().add(res.F).show()
np.savetxt(strF, res.F )
np.savetxt(strX, res.X )
