from ESN import ClasificacionESN
import numpy as np
from sklearn.metrics import accuracy_score

# The solution to evaluate
x = [ 3.985352835721425735e-01, 1.037272237917458845e-02, 5.410002342667400654e+00, 2.851864441397558636e+01, 8.568896374713877151e+01 ]
Datos = np.loadtxt( "../Datos/Wine/datos.txt" )
caracteristicas=13
clases = 3
print( Datos.shape )

noise = x[0]
leaking = x[1]
contenedor = int( x[2] )
semillaW = int( x[3] )
semillaP = int( x[4] )

longitud =len(Datos)
dobleces = 5
division = int(longitud / dobleces)
rangos = np.zeros((dobleces, 2))
entrenamiento = int(longitud - division)

r1 = 0
r2 = 0
for i in range(dobleces):
    r2 = division + r1
    rangos[i, 0] = r1
    rangos[i, 1] = r2
    r1 = r2

suma_eval = 0
suma_entrada = 0

esn = ClasificacionESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, 1, clases )
esn.loadMatrices( "Win.txt", "permutation.txt", "w.txt", "Wout.txt" )

prom=0
i=0
while i<dobleces :
	Xent = np.zeros((entrenamiento, caracteristicas))
	Yent = np.zeros((entrenamiento, clases))
	r1 = rangos[i, 0]
	r2 = rangos[i, 1]
	Xeval = Datos[int(r1):int(r2), 0:caracteristicas]
	Yeval = Datos[int(r1):int(r2), caracteristicas:caracteristicas+clases]
	c1 = 0

	j = 0
	while j < dobleces :
		if j != i :
			c2 = int(division) + c1
			r1e = int(rangos[j, 0])
			r2e = int(rangos[j, 1])
			Xent[c1:c2, :] = Datos[int(r1e):int(r2e), 0:caracteristicas]
			Yent[c1:c2, :] = Datos[int(r1e):int(r2e), caracteristicas:caracteristicas+clases]
			c1 = c2
		j += 1	
	i += 1

	#pred_ent = esn.predict( Xent )
	#exactitud_entrada = accuracy_score(Yent, pred_ent)

	pred_eval = esn.predictCompacta( Xeval )

	exactitud_evaluacion = accuracy_score( Yeval, pred_eval )
	prom += exactitud_evaluacion
	print("Test accuracy:", exactitud_evaluacion )


prom /= dobleces
print("Average test accuracy:", prom )
