from ESN import ClasificacionESN
from ESN import PredictionESN
from ESN import PredictionEncoderESN
from ESN import PredictionDeepESN
from ESN import PredictionIncESN
from sklearn.metrics import accuracy_score
from sklearn.metrics import mean_squared_error
from sklearn.metrics import r2_score
import numpy as np

def ValidacionAE(noise, contenedor, semillaW, semillaP, leaking, Data, Data1, caracteristicas, clases):
    Xent = np.loadtxt( Data )
    Xpru = np.loadtxt( Data1)
    esn = PredictionESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, caracteristicas, clases)
    esn.fitCompacta( Xent, Xent )

    pred_eval = esn.predictCompacta( Xpru )

    #print(pred_eval.shape)
    #print(pred_eval[0])
    #print(Xpru[0])
    MSE = mean_squared_error(pred_eval, Xpru )

    return MSE

def ValidacionAESim(noise, contenedor, semillaW, semillaP, leaking, Data, Data1, caracteristicas, clases, reduccion):
    Xent = np.loadtxt( Data )
    #print(Xent.shape)
    error = np.zeros((Xent.shape[0],1))
    #Xpru = np.loadtxt( Data1)
    
    esnEnconder = PredictionEncoderESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, caracteristicas, reduccion)
    Encoded = esnEnconder.predictCompacta( Xent )
    #print(Encoded)
    #print(Encoded.shape)
    esnDecoder = PredictionESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, reduccion, clases)
    #print("C")
    esnDecoder.fitCompacta( Encoded, Xent )
    #print("C")

    pred_eval = esnDecoder.predictCompacta( Encoded )

    #a = pred_eval - Xent

    #for i in range(Xent.shape[0]):
        #error[i,0] = np.dot(a[i], a[i].T)
    
    MSE = mean_squared_error(Xent, pred_eval )

    return MSE


def ValidacionRegresionDMM(noise, contenedor, semillaW, semillaP, leaking, Data, Data1, Data2, Data3, caracteristicas, clases):


    DatosE = np.loadtxt( Data )
    DatosES = np.loadtxt( Data1 )
    DatosP = np.loadtxt( Data2 )
    DatosPS = np.loadtxt( Data3 )
              
    esn = PredictionDeepESN(noise, leaking, contenedor, semillaW, semillaP, 0.5, 1, caracteristicas, clases)
                    
    esn.fitCompacta( DatosE, DatosES )
    
    pred_eval = esn.predictCompacta( DatosP )

    #pred_eval = np.empty(DatosPS.shape)
    #x = DatosP[0].reshape(1,3) 
    #print(x)
    #for i in range(DatosP.shape[0]):
        #y = esn.predictCompacta( x )
        #print(y.shape)
        #pred_eval[i, :] = y 
        #x = y

    MSE = mean_squared_error(DatosPS,  pred_eval)

    #print(str(prom_eval)+ " " + str(prom_entra)+ " x1:"+str(noise)+ " x2:"+str(leaking)+ " x3:" +str(contenedor)+ " x4:"+str(semilla) )

    return MSE

def ValidacionRegresionMM(noise, contenedor, semillaW, semillaP, leaking, Data, Data1, Data2, Data3, caracteristicas, clases):


    DatosE = np.loadtxt( Data )
    DatosES = np.loadtxt( Data1 )
    DatosP = np.loadtxt( Data2 )
    DatosPS = np.loadtxt( Data3 )
              
    esn = PredictionESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, caracteristicas, clases)
                    
    esn.fitCompacta( DatosE, DatosES )
    
    pred_eval = esn.predictCompacta( DatosP )

    #pred_eval = np.empty(DatosPS.shape)
    #x = DatosP[0].reshape(1,3) 
    #print(x)
    #for i in range(DatosP.shape[0]):
        #y = esn.predictCompacta( x )
        #print(y.shape)
        #pred_eval[i, :] = y 
        #x = y

    MSE = mean_squared_error(DatosPS,  pred_eval)

    #print(str(prom_eval)+ " " + str(prom_entra)+ " x1:"+str(noise)+ " x2:"+str(leaking)+ " x3:" +str(contenedor)+ " x4:"+str(semilla) )

    return MSE

def ValidacionRegIncMM(noise, contenedor, semillaW, semillaP, leaking, entrenamiento, fin, caracteristicas, clases):


    esn = PredictionIncESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, caracteristicas, clases)
    archivos = int(entrenamiento)
    #print("Entrenando")
    for i in range(archivos):
        #print(i)
        nombre = "../../../Documents/DatosF/Prueba"+str(i)+".txt"
        DatosE = np.loadtxt(nombre)
        if i == 0:
            esn.fitCompactaIncremental(DatosE[:, 1:8], DatosE[:, 0], True)
        else:
            esn.fitCompactaIncremental(DatosE[:, 1:8], DatosE[:, 0], False)
        if type(esn.WoutInc) is int:
            print('Problema')
            break
    
    if type(esn.WoutInc) is int:
        prom = 100000
    else:
        arch = int(fin - entrenamiento)
        #print(arch)   
        estadisticas = np.zeros(arch)
        #print("Prueba")
        for j in range(arch):
            t = int(j + entrenamiento)
            #print(t)
            #print(t)
            nombre = "../../../Documents/DatosF/Prueba"+str(t)+".txt"
            DatosEP = np.loadtxt(nombre)
            y_pred = esn.predictIncCompacta(DatosEP[:, 1:8])
            #MSE = mean_squared_error(DatosEP[:,0],  y_pred)
            estadisticas[j] = r2_score(DatosEP[:,0],  y_pred)

    resultado = abs(1 - np.mean(estadisticas))
    #print(resultado)

    return resultado


def ValidacionRegIncMM3(noise, contenedor, semillaW, semillaP, leaking, entrenamiento, fin, caracteristicas, clases):


    esn = PredictionIncESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, caracteristicas, clases)
    archivos = int(entrenamiento)
    #print("Entrenando")
    for i in range(archivos):
        #print(i)
        nombre = "../../../Documents/Jet/5/Prueba"+str(i)+".txt"
        DatosE = np.loadtxt(nombre)
        if i == 0:
            esn.fitCompactaIncremental(DatosE[:, 2:15], DatosE[:, 1], True)
        else:
            esn.fitCompactaIncremental(DatosE[:, 2:15], DatosE[:, 1], False)
        if type(esn.WoutInc) is int:
            #print('Problema')
            break
    
    if type(esn.WoutInc) is int:
        resultado = -100000000000
        desviacion = 100000000000
    else:
        arch = int(fin - entrenamiento)
        #print(arch)   
        estadisticas = np.zeros(arch)
        #print("Prueba")
        for j in range(arch):
            t = int(j + entrenamiento)
            #print(t)
            #print(t)
            nombre = "../../../Documents/Jet/5/Prueba"+str(t)+".txt"
            DatosEP = np.loadtxt(nombre)
            y_pred = esn.predictIncCompacta(DatosEP[:, 2:15])
            #MSE = mean_squared_error(DatosEP[:,0],  y_pred)
            estadisticas[j] = r2_score(DatosEP[:,1],  y_pred)

        resultado = np.mean(estadisticas)
        desviacion = np.std(estadisticas)
        if(np.isnan(resultado) or np.isinf(resultado)):
            resultado = -100000000001
        if(np.isnan(desviacion) or np.isinf(desviacion)):
            desviacion = 100000000001
    #print(resultado)

    return resultado, desviacion


def ValidacionRegresion(noise, contenedor, semillaW, semillaP, leaking, Data, Data1, caracteristicas, clases):


    DatosE = np.loadtxt( Data )
    DatosP = np.loadtxt( Data1 )

    n, m = DatosE.shape

    samples = m - 1

    # Todos los datos están en la matriz X
    # la última columna de X es la salida: X[:m-1]
    Xent = DatosE[0:n,0:samples]
    yent = DatosE[0:n,samples]
    yent = yent.reshape(-1, 1)
    #print( "Xent:", Xent.shape )
    #print( "yent:", yent.shape )

    n, m = DatosP.shape

    samples = m - 1

    Xpru = DatosP[0:n,0:samples]
    ypru = DatosP[0:n,samples]
    ypru = ypru.reshape(-1, 1)
    #print( "Xent:", Xpru.shape )
    #print( "yent:", ypru.shape )
              
    esn = PredictionESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, caracteristicas, clases)
                    
    esn.fitCompacta( Xent, yent )

    pred_eval = esn.predictCompacta( Xpru )
    
    RMSE = mean_squared_error(ypru,  pred_eval, squared=False)

    #print(str(prom_eval)+ " " + str(prom_entra)+ " x1:"+str(noise)+ " x2:"+str(leaking)+ " x3:" +str(contenedor)+ " x4:"+str(semilla) )

    return RMSE

def ValidacionCruzada(noise, contenedor, semillaW, semillaP, leaking, Data, caracteristicas, clases, store=0):
    Datos = np.loadtxt( Data )

    longitud =len(Datos)
    dobleces = 5

    division = int(longitud / dobleces)

    rangos = np.zeros((dobleces, 2))

    entrenamiento = int(longitud - division)

    r1 = 0
    r2 = 0
    for i in range(dobleces):
        r2 = division + r1
        rangos[i, 0] = r1
        rangos[i, 1] = r2
        r1 = r2

    #print(rangos)

    #v_exactitud_modelos = np.zeros((modelos, 2))
    #v_tiempo_modelos = np.zeros((len(c), 2))
                #Dobleces para la validación cruzada

    mimax = 0
    mii = 0

    suma_eval = 0
    suma_entrada = 0
    for i in range(dobleces):
        #print("k = ", i)
        Xent = np.zeros((entrenamiento, caracteristicas))
        Yent = np.zeros((entrenamiento, clases))
        r1 = rangos[i, 0]
        r2 = rangos[i, 1]
        Xeval = Datos[int(r1):int(r2), 0:caracteristicas]
        Yeval = Datos[int(r1):int(r2), caracteristicas:caracteristicas+clases]
        c1 = 0
        for j in range(dobleces):
            if j != i:
                c2 = int(division) + c1
                r1e = int(rangos[j, 0])
                r2e = int(rangos[j, 1])
                Xent[c1:c2, :] = Datos[int(r1e):int(r2e), 0:caracteristicas]
                Yent[c1:c2, :] = Datos[int(r1e):int(r2e), caracteristicas:caracteristicas+clases]
                c1 = c2
              
        esn = ClasificacionESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, 1, clases)
                    
        pred_ent = esn.fitCompacta( Xent, Yent )
        #pred_ent = esn.predict( Xent )
        #exactitud_entrada = accuracy_score(Yent, pred_ent)

        pred_eval = esn.predictCompacta( Xeval )
        exactitud_evaluacion = accuracy_score( Yeval, pred_eval )
        if exactitud_evaluacion > mimax :
            mimax = exactitud_evaluacion
            mii = i
        if store == 1 :
            print("Eval:", exactitud_evaluacion)
        suma_eval = suma_eval + exactitud_evaluacion
        #suma_entrada = suma_entrada + exactitud_entrada
    
    prom_eval = suma_eval / dobleces
    if store == 1 :
        print("Prom:", prom_eval )
    #prom_entra =  suma_entrada / 5
    #print(str(prom_eval)+ " " + str(prom_entra)+ " x1:"+str(noise)+ " x2:"+str(leaking)+ " x3:" +str(contenedor)+ " x4:"+str(semilla) )

    if store == 1 :
        i = mii
        Xent = np.zeros((entrenamiento, caracteristicas))
        Yent = np.zeros((entrenamiento, clases))
        r1 = rangos[i, 0]
        r2 = rangos[i, 1]
        Xeval = Datos[int(r1):int(r2), 0:caracteristicas]
        Yeval = Datos[int(r1):int(r2), caracteristicas:caracteristicas+clases]
        c1 = 0
        for j in range(dobleces):
            if j != i:
                c2 = int(division) + c1
                r1e = int(rangos[j, 0])
                r2e = int(rangos[j, 1])
                Xent[c1:c2, :] = Datos[int(r1e):int(r2e), 0:caracteristicas]
                Yent[c1:c2, :] = Datos[int(r1e):int(r2e), caracteristicas:caracteristicas+clases]
                c1 = c2
              
        esn = ClasificacionESN(noise, leaking, contenedor, semillaW, semillaP, 0.1, 1, 1, clases, 1 )
        pred_ent = esn.fitCompacta( Xent, Yent, 1 )
        #pred_ent = esn.predict( Xent )
        #exactitud_entrada = accuracy_score(Yent, pred_ent)

        pred_eval = esn.predictCompacta( Xeval )
        exactitud_evaluacion = accuracy_score( Yeval, pred_eval )
        print("Test accuracy:", exactitud_evaluacion )
        # suma_eval = suma_eval + exactitud_evaluacion
                
    return prom_eval
