from pymoo.core.problem import Problem
import pymoo.gradient.toolbox as anp
import utilidades as u
import sys
import numpy as np

class ESNTrain(Problem):
    def __init__(self, **kwargs):
        '''
            n_var : int                     Number of Variables
            n_obj : int                     Number of Objectives
            n_ieq_constr : int              Number of Inequality Constraints
            n_eq_constr : int               Number of Equality Constraints
            xl : np.array, float, int       Lower bounds for the variables. if integer all lower bounds are equal.
            xu : np.array, float, int       Upper bounds for the variable. if integer all upper bounds are equal.
            vtype : type                    The variable type. So far, just used as a type hint.
        '''

        super().__init__(n_var=5, 
                        n_obj=2,
                        xl=np.array([0, 0, 5, 0, 0]), 
                        xu=np.array([1, 1, 1000, 100, 100]), 
                        vtype=float)

    def _evaluate(self, x, out, *args, **kwargs):
        # x1 = NoiseLevel   x[:, 0]
        # x2 =  leaking     x[:, 1]
        # x3 = reservoir    x[:, 2]
        # x4 = seed 1   W    x[:, 3]
        # x5 = seed 2   P   x[:, 4]
        f = np.zeros((x.shape[0], 1))
        f2 = np.zeros((x.shape[0], 1))
        for i in range(x.shape[0]):
            x1 = x[i, 0]
            x2 = x[i, 1]
            x3 = int(x[i, 2])
            x4 = int(x[i, 3])
            x5 = int(x[i, 4])

			# Para un nuevo problema hay que cambiar las dos líneas siguientes
            Data = "Datos/Wine/datos.txt"
            f[i,0] = u.ValidacionCruzada(x1, x3, x4, x5, x2, Data, 13, 3 )
			# --------------------------------------------------------------
            f2[i,0] = x3 
            #print(str(i)+ " " + str(f[i,0])  )
            d=open('MejorEvo/Wine/NSGA2.txt','a')
            a = np.array([f[i,0], x3, x1, x2, x[i, 2], x[i, 3], x[i, 4]])
            np.savetxt(d, a, fmt='%f', newline=" ")
            d.write("\n")
            d.close()
      
        out["F"] = anp.column_stack([-f, f2])
        
        #out["F"] = f
        #out["F"] = (x[:, 0] ** 2 + x[:, 1] - 11) ** 2 + (x[:, 0] + x[:, 1] ** 2 - 7) ** 2
